<div *ngIf="noData()" class="upload-page">
  <div class="card bg-light ">
    <div class="card-header bg-dark text-light text-center">
      <strong>Upload your ngx-translate files (.json)</strong>
      <button type="button" class="btn btn-sm btn-outline-info pull-right" title="Info point" (click)="open(infoModal)">
        <i class="fa fa-info" aria-hidden="true"></i>
      </button>
    </div>
    <div class="card-body">
      <app-upload-manager (translationsUploaded)="loadTranslationsFromFile($event)"></app-upload-manager>
    </div>
    <div class="card-footer">
      <div>
        <small>Made with<i class="fa fa-heart m-1" style="color:red;" aria-hidden="true"></i>for the developers!</small>
      </div>
      <div class="text-right">
        <small><i>Copyright © <a href="http://www.enricoschintu.it" target="_blank">Enrico Schintu</a> 2019</i></small>
      </div>
    </div>
  </div>
</div>

<p-growl [(value)]="msgs" [baseZIndex]="100"></p-growl>
<div *ngIf="!noData()" class="fixed-top bg-dark text-light page-header">
  <div class="d-flex justify-content-between">
    <form *ngIf="!noData()" class="form-inline">
      <div class="input-group">
        <div class="input-group-prepend">
          <span class="input-group-text bg-warning">
            <i class="fa fa-search" aria-hidden="true"></i>
          </span>
        </div>
        <input class="form-control mr-sm-2" type="search" placeholder="Search TranslationCode"
               [(ngModel)]="searchFilter" name="searchFilter">
      </div>
      <button *ngIf="!noData()" type="button" class="btn btn-warning btn-sm" (click)="open(updateModal, null)"
              title="Add a new translation">
        <i class="fa fa-plus-circle mr-2" style="font-size: 12pt"></i>
        <span style="font-variant: small-caps; font-weight: bold">Add Translation</span>
      </button>
    </form>
    <!--    <span class="navbar-brand"><strong>TRANSLATIONS MANAGER</strong></span>-->
    <div class="btn-group" role="group" aria-label="OptionsGrp">
      <div>
        <a *ngFor="let download of downloads" class="btn btn-outline-info btn-sm" [title]="download.name"
           [href]="download.url" [download]="download.name">
          <i class="fa fa-cloud-download" aria-hidden="true"></i>
          <flag-icon country="{{getCountryFromFileName(download.name)}}" squared></flag-icon>
        </a>
      </div>
      <button *ngIf="!noData()" type="button" class="btn btn-danger btn-sm" (click)="refreshTranslations()"
              title="Close Manager">
        <i class="fa fa-times" aria-hidden="true"></i>
      </button>
    </div>
  </div>
  <div *ngIf="!noData()">
    <table class="table">
      <thead>
      <tr>
        <th scope="col">Translation Code</th>
        <th scope="col">Translation Values</th>
        <th scope="col" class="text-center">Edit Translation</th>
      </tr>
      </thead>
    </table>
  </div>
</div>

<div *ngIf="!noData()" class="page-body">
  <table class="table table-striped">
    <tbody>
    <tr *ngFor="let translationCode of getKeys()">
      <td>
        <b>{{translationCode}}</b>
      </td>
      <td>
        <p *ngFor="let language of languages">
          <b>{{language}}</b>:
          <span>{{getTranslationValue(translationCode, language).value}}</span>
        </p>
      </td>
      <td class="column-btn">
        <button class="btn btn-sm btn-secondary" (click)="open(updateModal, translationCode)">
          <i class="fa fa-pencil" aria-hidden="true"></i>
        </button>
      </td>
    </tr>
    </tbody>

  </table>
  <p *ngIf="translationsMap.size === 0">La mappa è vuota</p>
</div>


<ng-template #updateModal let-c="close" let-d="dismiss">
  <div class="modal-header">
    <h4 class="modal-title" id="modal-basic-title">
      <span *ngIf="!newTranslation">
        <b>TranslationCode:</b> {{translationsToUpdate[0]?.translationCode}}</span>
      <span *ngIf="newTranslation">
        <b>New TranslationCode</b>
      </span>
    </h4>
    <button type="button" class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form>
      <div class="form-group">
        <div *ngIf="newTranslation" class="input-group mb-3">
          <div class="input-group-prepend">
            <span class="input-group-text basic-addon3">
              <b>TranslationCode</b>
            </span>
          </div>
          <input type="text" class="form-control" id="basic-url" aria-describedby="basic-addon3"
                 [(ngModel)]="translationsToUpdate[0].translationCode"
                 name="translationCode">
        </div>
        <div class="input-group mb-3" *ngFor="let translation of translationsToUpdate">
          <div class="input-group-prepend input-label">
            <span class="input-group-text basic-addon3">
              <b>{{translation.languageCode}}</b>
            </span>
          </div>
          <input type="text" class="form-control" id="basic-url" aria-describedby="basic-addon3"
                 [(ngModel)]="translation.value" [name]="translation.languageCode">
          <div class="input-group-text">
            <input type="checkbox" aria-label="Checkbox for following text input"
                   [checked]="(translation.value || translation.value > 0)"
                   disabled="true">
          </div>
          <button class="btn btn-sm btn-danger" (click)="translation.value = null">
            <i class="fa fa-trash" aria-hidden="true"></i>
          </button>
        </div>
      </div>
    </form>
    <div class="mr-3 ml-3 mb-2">
      <google-translate></google-translate>
    </div>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-outline-danger" (click)="c('Close click')">Cancel</button>
    <button type="button" class="btn btn-outline-success"
            (click)="updateSelectTranslations(); c('Update translations')">Save
    </button>
  </div>
</ng-template>


<ng-template #infoModal let-c="close" let-d="dismiss">
  <div class="modal-header">
    <h4 class="modal-title" id="modal-basic-title">
      Example of a valid Json structure
    </h4>
    <button type="button" class="close" aria-label="Close" (click)="d('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <pre>{{jsonExample | json:4}}</pre>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-outline-danger" (click)="c('Close click')">Close</button>
  </div>
</ng-template>
